var _localStorage = window.localStorage; // local存储

var map = {};
map.loginPage = './login.html';
map.iframePage = './iframeLoader.html';

if(document.getElementById('wrapper')) { // 初始化scroll
	var scroll = new IScroll('#wrapper', {
		click: true,
		tap: true,
		mouseWheel: false
	});
	scroll.refresh();
}

if(typeof document.addEventListener != 'undefined') {
	document.addEventListener('touchmove', function(e) {
		e.preventDefault();
	}, false);
} else {
	document.attachEvent('touchmove', function(e) {
		e.preventDefault();
	});
}

var Common = {
    getQueryString: function (strParame) {
        var args = new Object();
        var query = location.search;
        var newQuery = query.substring(query.indexOf('?') + 1);
        var pairs = newQuery.split("&"); // Break at ampersand
        for (var i = 0; i < pairs.length; i++) {
            var pos = pairs[i].indexOf('=');
            if (pos == -1)
                continue;
            var argname = pairs[i].substring(0, pos);
            var value = pairs[i].substring(pos + 1);
            value = decodeURIComponent(value);
            args[argname] = value;
        }
        return args[strParame] || "";
    },
	// 退出登录
	logoutAccount: function(redirectURL) {
		Common.clearUserstorage();

		if(M_isIos) {
			try {
				webView.callNative('jPushLogout'); // webView  ios的webView是大写的V
			} catch(e) {
				alert('iOS: clear JPush exception');
			}
		}

		if(M_isAndroid) {
			try {
				webview.setAliasAndTags('', ''); // webview  android的webview是小写的v
			} catch(e) {
				alert('android: clear JPush exception');
			}
		}

		window.location.href = redirectURL;
	},
	unionLogin: function(url) {
		var ls = window.localStorage;
		var isLoginTime = window.btoa(new Date().getTime());
		//var question = url.indexOf('?');
		//if(question>0){
		//	url = url.substring(0,question);
		//}
		if(~url.indexOf('?')) {
			url += '&isLogined=' + isLoginTime;
		} else {
			url += '?isLogined=' + isLoginTime;
		}
		// 加上登录用户的account
		url += '&loginAccount=' + window.localStorage.getItem('_secAccount');;

		$.each(['_oaId', '_userId', '_userName'], appendParam);
		window.location.href = url;

		function appendParam(index, param) {
			var val = ls.getItem(param);
			if(val && val != 'null') {
				url = url + '&' + param + '=' + encodeURIComponent(val);
			}
		}
	},
	// 点击链接跳转
	redirectURL: function(url, title, loadmode, category) {
		//url = url.replace("servicetest.evergrande.com", "localhost");
		var reg = new RegExp("(^|&)color=([^&]*)(&|$)", "i");
		var r = url.substr(url.indexOf('?') + 1).match(reg);
		var color = "";
		if (r != null) {
			color = decodeURIComponent(r[2]);
			if(url.length < 15) return;
		}
		var _sessionStorage = window.sessionStorage; // session存储
		var _account = _localStorage.getItem('_account');

		Common.l(_account, title, url, category); // log 

		$('#btn-loading-tips').html('跳转中...');
		$('#ajax-loading').show();

		if(url.indexOf('http://') >= 0 || url.indexOf('https://') >= 0) {
			// 单点ems特殊处理
			if(url.indexOf('/rest/sso/exsystem/redirectUrl') > -1) {
				if(_account == null || _account == '') {
					alert('获取账号信息失败, 无法进行单点跳转');
					return 0;
				}
				url = url + '?&account=' + _account;
			}

			// 特殊处理动态传参
			if(url.indexOf('#accountName#') > -1 || url.indexOf('#account#') > -1 || url.indexOf('#name#') > -1 || url.indexOf('#phone#') > -1 || url.indexOf('#dept#') > -1 || url.indexOf('#card#') > -1 || url.indexOf('#oaid#') > -1 || url.indexOf('#deptid#') > -1 ||
				url.indexOf('#isLogined#') > -1) {
				/*    #account# 员工编号    #name# 员工名称    #phone# 员工号码    #dept# 员工所在部门    #card# 员工身份证号码  #oaid# 员工ems乱七八糟的编号   #deptId# ems部门编号 */
				var secAccount = window.localStorage.getItem('_secAccount');
				var secUserName = window.localStorage.getItem('_secName');
				var uname = window.localStorage.getItem('_u_userName');
				var secDept = window.localStorage.getItem('_secDept');
				var udept = window.localStorage.getItem('_u_dept');
				var secTelPhone = window.localStorage.getItem('_secPhone');
				var secCard = window.localStorage.getItem('_secCard');
				var _oaId = window.localStorage.getItem('_oaId');
				var _userId = window.localStorage.getItem('_userId');
				var _deptId = window.localStorage.getItem('_deptId');
				var isLoginTime = window.btoa(new Date().getTime());
				var _account = window.localStorage.getItem('_account');
				var _full_dept = window.localStorage.getItem('_full_dept');
				if(!secAccount || secAccount == 'null' && _account) {
					secAccount = window.btoa(_account);
				}
				url = url.replace(/#account#/g, secAccount)
				.replace(/#name#/g, secUserName)
				.replace(/#uname#/g, uname)
				.replace(/#phone#/g, secTelPhone)
				.replace(/#dept#/g, secDept)
				.replace(/#udept#/g, udept)
				.replace(/#card#/g, secCard)
				.replace(/#oaid#/g, _oaId)
				.replace(/#userid#/g, _userId)
				.replace(/#deptid#/g, _deptId)
				.replace(/#isLogined#/g, isLoginTime)
				.replace(/#accountName#/g, _account)
				.replace(/#fulldept#/g, _full_dept);
			}

			// 统一平台打包进APP里面，数据无法通过localStorage获取，所以数据保存到url里。
			if(url.indexOf('#unionEntryInApp#') > -1) {
				// 需要传输数据
				var _role = window.localStorage.getItem('_role');
				var isLogined = window.localStorage.getItem('isLogined');
				var _userId = window.localStorage.getItem('_userId');
				var _oaId = window.localStorage.getItem('_oaId');
				var _userName = window.localStorage.getItem('_userName');
				var _dept = window.localStorage.getItem('_dept');
				var _deptId = window.localStorage.getItem('_deptId');
				var _position = window.localStorage.getItem('_position');
				var _moblie = window.localStorage.getItem('_moblie');
				var _account = window.localStorage.getItem('_account');
				var _card = window.localStorage.getItem('_card');
				var _secondDept = window.localStorage.getItem('_secondDept');
				var _islunch_bus = window.localStorage.getItem('_islunch_bus');
				var _telPhone = window.localStorage.getItem('_telPhone'); //该号码用于优行酒店唯一标识
				//base64加密
				var _secPhone = window.localStorage.getItem('_secPhone');
				var _secDept = window.localStorage.getItem('_secDept');
				var _secAccount = window.localStorage.getItem('_secAccount');
				var _secName = window.localStorage.getItem('_secName');
				var _secCard = window.localStorage.getItem('_secCard');
				var token = window.localStorage.getItem('token');

				var unionEntryInApp = "&unionEntryInApp=1";
				unionEntryInApp = unionEntryInApp + "&_role=" + encodeURIComponent(_role);
				unionEntryInApp = unionEntryInApp + "&isLogined=" + encodeURIComponent(window.btoa(isLogined));
				unionEntryInApp = unionEntryInApp + "&_userId=" + encodeURIComponent(_userId);
				unionEntryInApp = unionEntryInApp + "&_oaId=" + encodeURIComponent(_oaId);
				unionEntryInApp = unionEntryInApp + "&_userName=" + encodeURIComponent(_userName);
				unionEntryInApp = unionEntryInApp + "&_dept=" + encodeURIComponent(_dept);
				unionEntryInApp = unionEntryInApp + "&_deptId=" + encodeURIComponent(_deptId);
				unionEntryInApp = unionEntryInApp + "&_position=" + encodeURIComponent(_position);
				unionEntryInApp = unionEntryInApp + "&_moblie=" + encodeURIComponent(_moblie);
				unionEntryInApp = unionEntryInApp + "&_account=" + encodeURIComponent(_account);
				unionEntryInApp = unionEntryInApp + "&_card=" + encodeURIComponent(_card);
				unionEntryInApp = unionEntryInApp + "&_secondDept=" + encodeURIComponent(_secondDept);
				unionEntryInApp = unionEntryInApp + "&_islunch_bus=" + encodeURIComponent(_islunch_bus);
				unionEntryInApp = unionEntryInApp + "&_telPhone=" + encodeURIComponent(_telPhone);
				unionEntryInApp = unionEntryInApp + "&_secPhone=" + encodeURIComponent(_secPhone);
				unionEntryInApp = unionEntryInApp + "&_secDept=" + encodeURIComponent(_secDept);
				unionEntryInApp = unionEntryInApp + "&_secAccount=" + encodeURIComponent(_secAccount);
				unionEntryInApp = unionEntryInApp + "&_secName=" + encodeURIComponent(_secName);
				unionEntryInApp = unionEntryInApp + "&_secCard=" + encodeURIComponent(_secCard);
				unionEntryInApp = unionEntryInApp + "&token=" + encodeURIComponent(token);
				url = url.replace(/#unionEntryInApp#/g, unionEntryInApp);
			}

			// iOS的是webView   android的是webview  注意字母V大小写的区别
			if(M_isAndroid) {
				try {
					if(loadmode == 'webview') {
						// 专门给有赞开发的打开方式
						if(url.indexOf('koudaitong') > -1) {
							if(_account == undefined || _account == null || _account == '') {
								alert('请使用合法的账号登录APP');
								return;
							}
							webview.openBrowserByAccount(title, url, _account); // 有赞的微信wap支付要用
						} else {
							webview.openBrowser(title, url, color);
						}
					} else if(loadmode == 'iframe') {
						_sessionStorage.setItem('iframe_title', title);
						console.log(url);
						_sessionStorage.setItem('iframe_url', url);
						window.location.href = map['iframePage'];
					} else {
						window.location.href = url;
					}
				} catch(e) {
					// webview调用失败则默认用iframe加载
					_sessionStorage.setItem('iframe_title', title);
					_sessionStorage.setItem('iframe_url', url);
					window.location.href = map['iframePage'];
				}
			} else if(M_isIos) {
				try {
					if(loadmode == 'webview') {
						webView.callNative('openBrowser:openUrl:navColor:', title, url, color);
					} else if(loadmode == 'iframe') {
						_sessionStorage.setItem('iframe_title', title);
						_sessionStorage.setItem('iframe_url', url);
						window.location.href = map['iframePage'];
					} else {
						window.location.href = url;
					}
				} catch(e) {
					_sessionStorage.setItem('iframe_title', title);
					_sessionStorage.setItem('iframe_url', url);
					window.location.href = map['iframePage'];
				}
			} else {
				// pc
				if(loadmode == 'iframe') {
					_sessionStorage.setItem('iframe_title', title);
					_sessionStorage.setItem('iframe_url', url);
					window.location.href = map['iframePage'];
				} else {
					window.location.href = url;
					return;
				}
			}
		} else if(url != '') {
			window.location.href =url;
		}
		Common.hideModel(300);

		// 特殊处理 ios手机浏览器catch不到webView异常  !important
		if(M_isIos) {
			//window.location.href = url;
			_sessionStorage.setItem('iframe_title', title);
			_sessionStorage.setItem('iframe_url', url);
			//window.location.href = map['iframePage'];
		}
	},
	getParam: function(name) {
		var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)");
		var r = window.location.search.substr(1).match(reg);
		if(r != null) return decodeURIComponent(r[2]);
		return null;
	},
	// log
	l: function(_account, title, url, category) {
		$.ajax({
			url: module_exports.entry.index + '/rest/platform/log',
			type: 'POST',
			data: {
				'accountId': _account,
				'linkName': title,
				'linkUrl': url,
				'category': category
			},
			dataType: 'text',
			success: function(data) {},
			error: function(e) {}
		});
	},
	hideModel: function(second) {
		setTimeout(function() {
			$('#ajax-loading').hide();
		}, second != undefined ? second : 1);
	},
	// 清除缓存
	clearUserstorage: function() {
		_localStorage.removeItem('_account');
		_localStorage.removeItem('isLogined');
		_localStorage.removeItem('_role');
		_localStorage.removeItem('t');
		_localStorage.removeItem('_card');
		_localStorage.removeItem('_dept');
		_localStorage.removeItem('_deptId');
		_localStorage.removeItem('_email');
		_localStorage.removeItem('_iphone');
		_localStorage.removeItem('_iphone123');
		_localStorage.removeItem('_islunch_bus');

		_localStorage.removeItem('_moblie');
		_localStorage.removeItem('_oaId');
		_localStorage.removeItem('_position');

		_localStorage.removeItem('_moblie');
		_localStorage.removeItem('_position');
		_localStorage.removeItem('_secAccount');
		_localStorage.removeItem('_secCard');
		_localStorage.removeItem('_secDept');
		_localStorage.removeItem('_secName');
		_localStorage.removeItem('_secPhone');
		_localStorage.removeItem('_secondDept');
		_localStorage.removeItem('_telPhone');
		_localStorage.removeItem('_userId');
		_localStorage.removeItem('_userName');
	}
};

/**
 * 判断设备
 */
(function() {
	var M_isPad = false;
	var jUserAgent = navigator.userAgent.toLowerCase();
	var jIsIphoneOs = jUserAgent.match(/iphone os/i) == 'iphone os',
		jIsIpad = jUserAgent.match(/ipad/i) == 'ipad',
		jIsAndroid = jUserAgent.match(/android/i) == 'android';
	if(jIsAndroid) {
		M_isAndroid = true;
		M_isIos = false;
		M_clientType = 'android';
		M_last_click_time = new Date().getTime();

		if(typeof document.addEventListener != 'undefined') {
			document.addEventListener('click', function(e) {
				M_click_time = new Date().getTime() //e['timeStamp'];
				if(M_click_time && (M_click_time - M_last_click_time) < 500) {
					try {
						e.stopImmediatePropagation();
					} catch(e) {}
					try {
						e.preventDefault();
					} catch(e) {}
					return false;
				}
				M_last_click_time = M_click_time;
			}, true);
		} else {
			document.attachEvent('click', function(e) {
				M_click_time = new Date().getTime() //e['timeStamp'];
				if(M_click_time && (M_click_time - M_last_click_time) < 500) {
					try {
						e.stopImmediatePropagation();
					} catch(e) {}
					try {
						e.preventDefault();
					} catch(e) {}
					return false;
				}
				M_last_click_time = M_click_time;
			});
		}
	} else if(jIsIphoneOs || jIsIpad) {
		M_isAndroid = false;
		M_isIos = true;
		M_clientType = 'ios';
		if(jIsIpad) {
			M_isPad = true;
		}
	} else {
		M_isAndroid = false;
		M_isIos = false;
		M_clientType = 'other';
	}
})();