$(document).ready(function() {
	if('message' == Common.getParam('type') || window.localStorage.getItem("_isMsg")) {
		window.location.href = './message.html'; // 直接去消息中心
		return;
	}

	if(IndexPage.isLogined()) {
		IndexPage.loadUserinfo();
		IndexPage.initData(); // ajax设为同步
		IndexPage.initMsg(); // 加载消息中心
		IndexPage.bindDomEvent();

		// 防止刷新不到scroll,滚动条滚不到底部
		setTimeout(function() {
			scroll.refresh();
		}, 500);
	} else {
		alert('您还没有登录！');
		window.location.href = map['loginPage'];
	}
});

var IndexPage = {
	isLogined: function() {
		// 注意: localStorage在ie不支持file:///方式访问,只能用http访问
		var pageLocalStorage = window.localStorage;
		var isLogined = pageLocalStorage.getItem('isLogined');
		if(isLogined == null || isLogined == '0') {
			return false;
		} else {
			return true;
		}
	},
	loadUserinfo: function() {
		var _localStorage = window.localStorage;
		var _account = _localStorage.getItem('_account');
		var _username = _localStorage.getItem('_userName');
		var _department = _localStorage.getItem('_dept');
		var _phone = _localStorage.getItem('_telPhone');
		var _cancelPhone = _localStorage.getItem('_cancelPhone');

		$('#ems-account').html(_account);
		$('#user-name').html(_username);
		$('#ems-dept').html(_department);

		_phone || _cancelPhone || (_localStorage.setItem('_cancelPhone', 1), $('#mask').show());
	},
	initData: function() {
		// 初始化默认数据
		var _localStorage = window.localStorage;
		var _userId = _localStorage.getItem('_userId');
		if(_userId == null) {
			$('#ajax-loading').show();
			$('#btn-loading').hide();
			$('#btn-loading-error').html('获取用户信息失败').show();
			return 0;
		}
		$.ajax({
			async: false, // 同步
			url: module_exports.entry.index + '/rest/platform/getPlatformDesktopConfig',
			type: 'GET',
			data: { 'userId': parseInt(_userId) },
			dataType: 'json',
			beforeSend: function() {
				$('#ajax-loading').show();
			},
			success: function(data) {
				if(!data.result) {
					$('#btn-loading').hide();
					$('#btn-loading-error').html('获取数据失败: ' + data.objValue).show();
					return 0;
				}
				$('#ajax-loading').hide();
				var jsonResult = data.objValue;

				// 头部广告栏
				var advertHTML = '';
				var advertList = jsonResult.advertList;
				for(var index in advertList) {
					var src = advertList[index]['src'];
					var name = advertList[index]['name'];
					var loadmode = advertList[index]['loadmode'];
					var targeturl = advertList[index]['targeturl'];
					
					if(targeturl.indexOf('?') > -1){
						targeturl = targeturl + "&color=" + encodeURIComponent(advertList[index]['color']);
					} else {
						targeturl = targeturl + "?color=" + encodeURIComponent(advertList[index]['color']);
					}

					advertHTML +=
						'<div class="advert-item" href="' + targeturl + '" name="' + name + '" loadmode="' + loadmode + '" data-category="advertItem">' +
						'<img class="advert-item-responsive-height" src="' + src + '" alt="' + name + '"/>' +
						'</div>';
				}
				$('#advertWrapper').html(advertHTML);

				// 工作栏
				var taskHTML = '';
				var tasklist = jsonResult.taskList;
				var group = []; // 每8个分成一组
				for(var i = 0, len = tasklist.length; i < len; i += 8) {
					group.push(tasklist.slice(i, i + 8));
				}
				// 对每组数据进行再次遍历
				for(var index in group) {
					var items = '';
					var g = group[index];
					for(var i = 0, len = g.length; i < len; i++) {
						var src = g[i]['src'];
						var name = g[i]['name'];
						var id = g[i]['id'];
						var loadmode = g[i]['loadmode'];
						var targeturl = '#parent'; // 默认是子层
						var level = g[i]['level'];
						if(level == 'top') { // 只有直链接才能设置href的值, 父链接默认用#parent防止页面跳转
							targeturl = g[i]['targeturl'];
							if(targeturl.indexOf('?') > -1){
								targeturl = targeturl + "&color=" + encodeURIComponent(g[i]['color']);
							} else {
								targeturl = targeturl + "?color=" + encodeURIComponent(g[i]['color']);
							}
						}
						items +=
							'<div href="' + targeturl + '" name="' + name + '" loadmode="' + loadmode + '" class="widget task-item" data-id="button" data-parentid="' + id + '" data-level="' + level + '" data-category="taskItem" >' +
							'<div class="widget-icon task-item-icon">' +
							'<img src="' + src + '" alt="' + name + '"/>' +
							'</div>' +
							'<div class="widget-title task-item-title split-text">' +
							name +
							'</div>' +
							'</div>';
					}
					taskHTML += '<div style="margin: auto; width: 100%;">' + items + '</div>'; // 每组用一个div包住
				}
				$('#taskWrapper').html(taskHTML);

				// 二级
				var subTaskList = jsonResult.subTaskList;
				var subTaskHTML = '';
				for(var index in subTaskList) {
					var src = subTaskList[index]['src'];
					var name = subTaskList[index]['name'];
					var parentid = subTaskList[index]['parentid'];
					var loadmode = subTaskList[index]['loadmode'];
					var targeturl = subTaskList[index]['targeturl'];
					var level = subTaskList[index]['level'];
					if(targeturl.indexOf('?') > -1){
						targeturl = targeturl + "&color=" + encodeURIComponent(subTaskList[index]['color']);
					} else {
						targeturl = targeturl + "?color=" + encodeURIComponent(subTaskList[index]['color']);
					}
					subTaskHTML +=
						'<div href="' + targeturl + '" name="' + name + '" loadmode="' + loadmode + '" class="widget task-item" data-id="button" data-parentid="' + id + '" data-level="' + level + '" data-category="taskItem">' +
						'<div class="widget-icon task-item-icon">' +
						'<img src="' + src + '" alt="' + name + '"/>' +
						'</div>' +
						'<div class="widget-title task-item-title split-text">' +
						name +
						'</div>' +
						'</div>';
				}
				$('#second-container').html(subTaskHTML);

				// 内部产品
				var internallist = jsonResult.internalLinkList;
				var result = [];
				for(var i = 0, len = internallist.length; i < len; i += 6) {
					result.push(internallist.slice(i, i + 6));
				}
				var internalHTML = '';
				for(var index in result) {
					var item = '';
					for(var i = 0; i < result[index].length; i++) {
						var src = result[index][i]['src'];
						var name = result[index][i]['name'];
						var loadmode = result[index][i]['loadmode'];
						var targeturl = result[index][i]['targeturl'];

						var nameAyyay = name.split('#');
						var procName = nameAyyay[0] != null ? nameAyyay[0] : '&nbsp;';
						var procDesc = nameAyyay[1] != null ? nameAyyay[1] : '&nbsp;';
						if(targeturl.indexOf('?') > -1){
							targeturl = targeturl + "&color=" + encodeURIComponent(result[index][i]['color']);
						} else {
							targeturl = targeturl + "?color=" + encodeURIComponent(result[index][i]['color']);
						}
						var gradNo = "grad" + i;
						item +=
							'<div id="' + gradNo + '" + href="' + targeturl + '" name="' + procName + '" loadmode="' + loadmode + '" class="widget internal-item" data-id="button" data-category="internalItem">' +
							'    <div class="widget-icon internal-item-icon">' +
							'        <img src="' + src + '" alt="' + procName + '"/>' +
							'    </div>' +
							'    <div class="widget-title internal-item-title">' +
							'    	<div class="internal-item-title-text split-text"><span>' + procName + '</span></div>' +
							'    	<div class="internal-item-title-text split-text item-desc">' + procDesc + '</div>' +
							'    </div>' +

							'</div>';
					}
					internalHTML += '<div>' + item + '</div>';
				}
				if(internallist && internallist.length > 0) {
					$('#internalWrapperTitle').show();
				}
				$('#internalWrapper').html(internalHTML);

				// 外部链接
				var externalList = jsonResult.externalLinkList;
				var result = [];
				for(var i = 0, len = externalList.length; i < len; i += 8) {
					result.push(externalList.slice(i, i + 8));
				}
				var externalHTML = '';
				for(var index in result) {
					var item = '';
					for(var i = 0; i < result[index].length; i++) {
						var src = result[index][i]['src'];
						var name = result[index][i]['name'];
						var loadmode = result[index][i]['loadmode'];
						var targeturl = result[index][i]['targeturl'];
						if(targeturl.indexOf('?') > -1){
							targeturl = targeturl + "&color=" + encodeURIComponent(result[index][i]['color']);
						} else {
							targeturl = targeturl + "?color=" + encodeURIComponent(result[index][i]['color']);
						}
						item +=
							'<div href="' + targeturl + '" name="' + name + '" loadmode="' + loadmode + '" class="widget external-item" data-id="button" data-category="externalItem">' +
							'	<div class="widget-icon external-item-icon">' +
							'		<img alt="' + name + '" src="' + src + '" style="width: 50px; height: 50px;">' +
							'	</div>' +
							'	<div class="widget-title external-item-title">' +
							'		<div class="external-item-title-text split-text">' + name + '</div>' +
							'	</div>' +
							'</div>';
					}
					externalHTML += '<div>' + item + '</div>';
				}
				if(externalList && externalList.length > 0) {
					$('#externalWrapperTitle').show();
				}
				$('#externalWrapper').html(externalHTML);

				// 动态tab
				var tabList = jsonResult.tabLinkList;
				var tabCount = 2; // 默认有[首页]和[我的]
				if(tabList != null && tabList.length > 0) {
					var newTabCount = tabList.length;
					var tabWidth = (100 / (tabCount + newTabCount)).toFixed(3); // 默认会四舍五入, 所以取3位，再截取即可(123.7849 -->123.785)           
					tabWidth = tabWidth.substring(0, tabWidth.lastIndexOf('.') + 3); // 截取后两位(123.78)

					for(var index in tabList) {
						var src = tabList[index]['src'];
						var name = tabList[index]['name'];
						var loadmode = tabList[index]['loadmode'];
						var targeturl = tabList[index]['targeturl'];
						if(targeturl.indexOf('?') > -1){
							targeturl = targeturl + "&color=" + encodeURIComponent(tabList[index]['color']);
						} else {
							targeturl = targeturl + "?color=" + encodeURIComponent(tabList[index]['color']);
						}
						$('#btn-bar-home').after(
							'<li class="btn-bar" data-name="' + name + '" data-href="' + targeturl + '" data-loadmode="' + loadmode + '" data-category="tabItem" onclick="IndexPage.bindTabDynamicClick(this);">' +
							'<div class="bar-body">' +
							'	<div class="bar-img">' +
							'		<img alt="AD" src="' + src + '" style="width: 18px; height: 18px; opacity: .6; filter: Alpha(opacity=.6);">' +
							'	</div>' +
							'	<div class="bar-title">' +
							name +
							'	</div>' +
							'</div>' +
							'</li>'
						);
					}
					$('.btn-bar').css({ width: tabWidth + '%' });
				}

				// 以下方法调用顺序不能变
				IndexPage.initOwl(advertList.length, group.length, internallist.length, result.length);
				IndexPage.advertImgDefaultConfig();
				IndexPage.taskHandler();
				// IndexPage.bindTabDomEvent();

				//$('.owl-prev').hide();

				// 隐藏初始化框
				$('.initframe').removeClass('initframe');
				$('.initframe50').removeClass('initframe50');
				$('.initframe100').removeClass('initframe100');
				$('.initframe215').removeClass('initframe215');
				$('.up-row-split').css({ height: '0px' });

				// 所有元素加载完成后重新渲染iscroll(计算滚动条的高度)
				scroll.refresh();
			},
			error: function(e) {
				$('#btn-loading').hide();
				$('#btn-loading-error').html('网络异常, 点击重新加载 ').show();
				return 0;
			}
		});
	},
	initOwl: function(advertSize, taskSize, internalSize, externalSize) {
		// 实例化轮播组件
		var optionAdvert = { items: 1, nav: false, dots: false, navContainerClass: '', controlsClass: 'owlControls-inner' };
		if(advertSize > 1) {
			optionAdvert = {
				items: 1,
				//lazyLoad: true,
				loop: true,
				margin: 1,
				autoplay: true,
				nav: false,
				dots: true,
				navContainerClass: '', // 设置为空,则没有导航按钮
				controlsClass: 'owlControls-inner'
			};
		}
		$('.owl-carousel-advert').owlCarousel(optionAdvert);

		var optionTask = {
			items: 1,
			nav: false,
			dots: false
		};
		if(taskSize > 1) {
			optionTask = {
				items: 1,
				lazyLoad: true,
				loop: false,
				margin: 1,
				autoplay: false,
				controlsClass: '',
				navContainerClass: 'task-nav',
				dots: false,
				navigation: true,
				navigationText: ["", ""],
				rewindNav:false
				/*afterMove:function(){
					alert('2');
				},
				afterInit:function(){
					alert('1');
				}*/
			};
		}

		$('.owl-carousel-task').owlCarousel(optionTask);

		var optionExternal = { items: 1, nav: false, dots: false };
		if(externalSize > 1) {
			optionExternal = {
				loop: false,
				margin: 10,
				autoplay: false,
				nav: false,
				dots: true,
				items: 1,
				controlsClass: 'owlControls',
				navContainerClass: ''
			};
		}
		$('.owl-carousel-external').owlCarousel(optionExternal);
	},
	initMsg: function() {
		var _userId = window.localStorage.getItem('_userId');
		var msgCenter = $('.msg-center');
		msgCenter.removeClass('unread').click(function() {
			//window.location.href = './message.html';
            var HREF ="message.html";
            Common.redirectURL(HREF,'消息中心','webview',"#EC4847");
		});
		$.ajax({
			url: module_exports.entry.index + '/rest/userMessageState/getByUid',
			type: 'POST',
			data: { 'userid': parseInt(_userId) },
			dataType: 'json',
			success: function(data) {
				if(!data.success) {
					return 0;
				}
				var message = data.returnValue;
				if(!message.messageState) {
					msgCenter.addClass('unread').click(function() {
						$.ajax({
							url: module_exports.entry.index + '/rest/userMessageState/updateByUid',
							type: 'POST',
							data: { 'userid': parseInt(_userId) }
						})
					});
				}
			},
			error: function(e) {
				//$('#ajax-loading').hide();
				//$('#btn-loading').hide();
				//$('#btn-loading-error').html('网络异常, 点击重新加载 ').show();
				return 0;
			}
		});
	},
	advertImgDefaultConfig: function() {
		// 广告栏图片加载失败使用默认图片
		$('.advertItemClass').bind('error', function() {
			// 必须先解绑error事件再加载默认图片, 因为如果默认图片没有的话会无限死循环导致内存溢出
			$(this).unbind('error').attr('src', './assets/default.png');
		});
	},
	taskHandler: function() {
		// 工作栏绑定事件
		$('.task-item').on('click', function() {
			var level = $(this).attr('data-level');
			if(level == 'top') {
				// 直接访问外链
				Common.redirectURL($(this).attr('href'), $(this).attr('name'), $(this).attr('loadmode'), $(this).data('category'));
			} else if(level == 'parent') {
				// 打开二级菜单
				var parentid = $(this).attr('data-parentid');
				$('.subTaskUnactive').hide();
				$('.subTaskItem' + parentid).show();

				$('#wrapper').hide();
				$('#page-second-task').slideDown(300, (function(parentid) {})(parentid));
			}
		});

		$('.advert-item, .internal-item, .external-item').on('click', function() {
			Common.redirectURL($(this).attr('href'), $(this).attr('name'), $(this).attr('loadmode'), $(this).data('category'));
		});
	},
	bindDomEvent: function() { // 绑定默认事件
		// 重新加载数据
		$('#btn-loading-error').on('click', function() {
			$('#btn-loading').show();
			$('#btn-loading-error').hide();
			IndexPage.initData();
		});

		// 返回一级页面
		$('#btn-hide-page-second').on('click', function() {
			var param = '0';
			$('#wrapper').slideDown();
			$('#page-second-task').slideUp(300);
			//$('#page-second-task').slideUp(300, (function(param){ })(param));
		});

		IndexPage.bindTabDomEvent();
	},
	bindTabDomEvent: function() {
		// 底部工具栏
		$('.init-bar').on('click', function(event) {
		    if($(this).attr('id') === 'btn-bar-mine'){
                Common.redirectURL('mine.html','closeTitle','webview');
            }else if($(this).attr('id') === 'btn-bar-home'){
                window.location.reload();
            }
			event.stopPropagation();
		});
	},
	bindTabDynamicClick: function(obj) {
		Common.redirectURL($(obj).data('href'), $(obj).data('name'), $(obj).data('loadmode'), $(obj).data('category'));
	}
};