/**
 * 全局变量
 */
var _localStorage = window.localStorage;
//判断是否去消息中心：
var isMsg = Common.getParam('type') == 'message';

/**
 * 页面加载完成(不含图片)
 */
$(document).ready(function(){
	isMsg || loginPage.clearUserstorage();//如果是去消息中心就不要clear
	if(window.location.search){
		var $switch = $('#switch-btn');
		$switch.attr('href', $switch.attr('href')+window.location.search);
	}
	loginPage.init();
	loginPage.bindDomEvent();
});

var loginPage = {
	init: function(){
		if(_localStorage){
			if(isMsg && _localStorage.getItem('isLogined')){
				_localStorage.setItem('_isMsg', true);
				var data = {};
				data.objValue = {
					account: _localStorage.getItem('_account'),
					fullDept: _localStorage.getItem('_fullDept')
				};
				this.successRedirect(data);
				return;
			}
			var username = _localStorage.getItem('hdusername');
			var pwd = _localStorage.getItem('hdpwd');

		}else{
			$('#error-msg').html('浏览器不支持本地存储');
		}
	},
	bindDomEvent: function(){
		// 登录事件
		var loginThis = this;
		$('#btn-submit').click(function(){
			loginThis.handlerSubmit();
		});
		var locker = false;
		$('#getCode').click(function () {
			var phone = $('#phone').val();
			if(!/^1\d{10}$/.test(phone)){
				$('#error-msg').html('请输入正确的手机号码！').show().fadeOut(5000);
				return;
			}
			if(locker) return;
			locker = true;
			var $timer= $('#getCode');
			$timer.addClass('locked').countdown(new Date().getTime()+59e3,
					function(event) {
						$(this).text(event.strftime('%S秒'));
			}).on('finish.countdown', finishCountDown)
			loginPage.getCode(phone,finishCountDown)
			function finishCountDown() {
				locker = false;
				$timer.text('获取验证码').removeClass('locked');
			}
		})
		
		$('.input-clear').on('click', function() {
			$(this).siblings('input').val('');
			$(this).hide();
		});
		
		$('.input-radius').on('input propertychange',function(){
			if($.trim($(this).val()) != ''){
				$(this).siblings('.input-clear').show();
			}else{
				$(this).siblings('.input-clear').hide();
			}
		});
	},
	getCode: function(phone,finishCountDown){ //getVerificationCode
		$.ajax({
			type: 'POST',
			url: module_exports.entry.index + '/rest/verificationCode/getVerificationCode',
			data:{phone:phone,type:0},
			dataType: 'json',
			success:function(data){
				if(data.success){
//							console.log(data);
//							$('#code').val(1234);
				}else{
					$('#error-msg').show().html('获取验证码失败: ' + data.errorReason).fadeOut(5000);
					if(typeof finishCountDown == 'function'){
						$('#getCode').countdown(new Date().getTime());
						finishCountDown();
					}
				}
			},
			error: function(e){
				$('#error-msg').show().html('网络异常, 请稍后重试!').fadeOut(5000);
			}
		});
	},
	handlerSubmit: function(){
		var loginThis = this;
		var phone = $('#phone').val();
		var code = $('#code').val();
		if(!phone || !code){
			$('#error-msg').html('手机号、验证码不能为空').show().fadeOut(5000);
			return 0;
		}
		if(!/^1\d{10}$/.test(phone)){
			$('#error-msg').html('请输入正确的手机号码！').show().fadeOut(5000);
			return 0;
		}
		$.ajax({
			url: module_exports.entry.index + '/rest/index/loginPhone',
			data: {'phone': phone, 'code': code},// todo: 改为手机、验证码
			dataType: 'json',
			beforeSend: function () {
				$('#ajax-loading').show();
	  		},
			success:function(data){
				if(data.result){
					loginThis.saveUserInfo(data); // 保存本地存储
					loginThis.successRedirect(data); // 定向到首页
				}else{
					$('#ajax-loading').hide();
					var msg = data.value;
                    $('#error-msg').html(msg);
				}
			},
			error:function(){
				$('#ajax-loading').hide();
				$('#error-msg').html('网络异常, 请稍后重试').show().fadeOut(5000);
			}
		});
	},
	saveUserInfo: function(data){
		// 保存用户各种信息
		var isMgr = 0;
		for(var i=0;i<data.objValue.roles.length;i++){
			var role = data.objValue.roles[i];
			if(role.roleId == 2){
				isMgr = 2;
				break;
			}
		}
		_localStorage.setItem('_role', isMgr);
		_localStorage.setItem('isLogined', 1);
		_localStorage.setItem('_userId', data.objValue.userId);
		_localStorage.setItem('_oaId', data.objValue.oaid);
		_localStorage.setItem('_userName', data.objValue.userName);
		_localStorage.setItem('_dept', data.objValue.dept);
		_localStorage.setItem('_deptId', data.objValue.deptId);
		_localStorage.setItem('_position', data.objValue.position);
		_localStorage.setItem('_moblie', data.objValue.moblie);
		_localStorage.setItem('_account', data.objValue.account);
		_localStorage.setItem('_card', data.objValue.card);
		_localStorage.setItem('_secondDept', data.objValue.secondDept);
		_localStorage.setItem('_islunch_bus', data.objValue.islunch_bus);
		_localStorage.setItem('_telPhone', data.objValue.telPhone || '');//该号码用于优行酒店唯一标识
		_localStorage.setItem('_fullDept', data.objValue.fullDept);//用于极光推送
		isMsg && _localStorage.setItem('_isMsg', isMsg);
		//base64加密
		_localStorage.setItem('_secPhone', data.objValue.secPhone);
		_localStorage.setItem('_secDept', data.objValue.secDept);
		_localStorage.setItem('_secAccount', data.objValue.secAccount);
		_localStorage.setItem('_secName', data.objValue.secName);
		_localStorage.setItem('_secCard', data.objValue.secCard);
	},
	successRedirect: function(data){
		var jUserAgent = navigator.userAgent.toLowerCase();
		var jIsIphoneOs = jUserAgent.match(/iphone os/i) == 'iphone os';
		var jIsAndroid = jUserAgent.match(/android/i) == 'android';
		
		var fullDept = '';
		if(data.objValue.fullDept != '' && data.objValue.fullDept != null && data.objValue.fullDept != undefined){
			fullDept = data.objValue.fullDept.split('>>');
		}

		// 极光推送tags长度有限制。
		fullDept = fullDept.toString().substring(0,38);
		
		if(jIsIphoneOs){
			try{
				webView.callNative('jPush:setTags:', data.objValue.account, fullDept);
			}catch(e){
				if('redirect'==Common.getParam('type')){
					Common.unionLogin(Common.getParam('url'));
				}else{
					window.location.href = './app.html';
				}
			}
		}
		if(jIsAndroid){
			try{
				webview.setAliasAndTags(data.objValue.account, fullDept);
			} catch(e){
				if('redirect'==Common.getParam('type')){
					Common.unionLogin(Common.getParam('url'));
				}else{
					window.location.href = './app.html';
				}
			}
		}
		// pc
		if('redirect'==Common.getParam('type')){
			Common.unionLogin(Common.getParam('url'));
		}else{
			window.location.href = './app.html';
		}

	},
	clearUserstorage: function(){
		_localStorage.removeItem('_account');
		_localStorage.removeItem('isLogined');
		_localStorage.removeItem('_role');
		_localStorage.removeItem('t');
		_localStorage.removeItem('_card');
		_localStorage.removeItem('_dept');
		_localStorage.removeItem('_deptId');
		_localStorage.removeItem('_email');
		_localStorage.removeItem('_iphone');
		_localStorage.removeItem('_iphone123');
		_localStorage.removeItem('_islunch_bus');
		
		_localStorage.removeItem('_moblie');
		_localStorage.removeItem('_oaId');
		_localStorage.removeItem('_position');
		
		_localStorage.removeItem('_moblie');
		_localStorage.removeItem('_position');
		_localStorage.removeItem('_secAccount');
		_localStorage.removeItem('_secCard');
		_localStorage.removeItem('_secDept');
		_localStorage.removeItem('_secName');
		_localStorage.removeItem('_secPhone');
		_localStorage.removeItem('_secondDept');
		_localStorage.removeItem('_telPhone');
		_localStorage.removeItem('_userId');
		_localStorage.removeItem('_userName');
		_localStorage.removeItem('_fullDept');
		_localStorage.removeItem('_cancelPhone');
		_localStorage.removeItem('_isMsg');
	}
};


