
$(document).ready(function(){
	// 初始化tab
	Mine.initTab();
	Mine.initMsg();
});

var Mine = {
	_userId: window.localStorage.getItem('_userId'),
	bindTabEvent: function(){
		$('.init-bar').on('click', function(event){
            if($(this).attr('id') === 'btn-bar-home'){
                Common.redirectURL('app.html','closeTitle','webview');
            }else if($(this).attr('id') === 'btn-bar-mine'){
                window.location.reload();
            }
            event.stopPropagation();
		});
	},
	bindTabDynamicClick: function(obj){
		var url =$(obj).data('href');
		Common.redirectURL(url, $(obj).data('name'), $(obj).data('loadmode'), $(obj).data('category'));
	},
	initTab: function(){
		var _userId = this._userId;
		$.ajax({
			//async: false, // 同步
			url: module_exports.entry.index + '/rest/platform/getPlatformTabConfig',
			type: 'GET',
			data: {'userId': parseInt(_userId)},
			dataType: 'json',
			beforeSend: function () {
				//$('#ajax-loading').show();
	  		},
			success: function(data){
				if(!data.result){
					//$('#btn-loading').hide();
					//$('#ajax-loading').hide();
					return 0;
				}
				//$('#ajax-loading').hide();
				var jsonResult = data.objValue;
				
				// 动态tab
				var tabList = jsonResult.tabLinkList;
				var tabCount = 2; // 默认有[首页]和[我的]
				if(tabList != null && tabList.length > 0){
					var newTabCount = tabList.length;
					var tabWidth = (100/(tabCount + newTabCount)).toFixed(3); // 默认会四舍五入, 所以取3位，再截取即可(123.7849 -->123.785)           
					tabWidth = tabWidth.substring(0, tabWidth.lastIndexOf('.') + 3); // 截取后两位(123.78)
					
					for(var index in tabList){
						var src = tabList[index]['src'];
						var name = tabList[index]['name'];
						var loadmode = tabList[index]['loadmode'];
						var targeturl = tabList[index]['targeturl'];
						
						$('#btn-bar-home').after(
						'<li class="btn-bar" data-name="'+ name +'" data-href="'+ targeturl +'" data-loadmode="'+ loadmode +'" data-category="tabItem" onclick="Mine.bindTabDynamicClick(this);">'
						+	'<div class="bar-body">'
						+	'	<div class="bar-img">'
						+	'		<img alt="AD" src="'+ src +'" style="width: 18px; height: 18px; opacity: .6; filter: Alpha(opacity=.6);">'
						+	'	</div>'
						+	'	<div class="bar-title">'
						+ 	name
						+	'	</div>'
						+	'</div>'
						+	'</li>'
						);
					}
					$('.btn-bar').css({width: tabWidth + '%'});
				}
				
				// 底部工具栏
				Mine.bindTabEvent();
				
				// 所有元素加载完成后重新渲染iscroll(计算滚动条的高度)
				//scroll.refresh();
			},
			error: function(e){
				//$('#ajax-loading').hide();
				//$('#btn-loading').hide();
				//$('#btn-loading-error').html('网络异常, 点击重新加载 ').show();
                // 底部工具栏
                Mine.bindTabEvent();
				return 0;
			}
		});
	},
	initMsg: function () {
		var _userId = this._userId;
		var msgCenter = $('#msg-center');
		msgCenter.removeClass('unread').click(function () {
			//window.location.href = './message.html';
            var HREF ="message.html";
            Common.redirectURL(HREF,'消息中心','webview',"#EC4847");
		});
		$.ajax({
			url: module_exports.entry.index + '/rest/userMessageState/getByUid',
			type: 'POST',
			data: {'userid': parseInt(_userId)},
			dataType: 'json',
			beforeSend: function () {
				//$('#ajax-loading').show();
			},
			success: function(data){
				if(!data.success){
					return 0;
				}
				var message = data.returnValue;
				if(!message.messageState){
					msgCenter.addClass('unread').click(function () {
						$.ajax({
							url: module_exports.entry.index + '/rest/userMessageState/updateByUid',
							type: 'POST',
							data: {'userid': parseInt(_userId)}
						})

					});
				}
			},
			error: function(e){
				//$('#ajax-loading').hide();
				//$('#btn-loading').hide();
				//$('#btn-loading-error').html('网络异常, 点击重新加载 ').show();
				return 0;
			}
		});
	}
};
